--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/build_load_connect.sh	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/build_load_connect.sh	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,69 @@
+#!/bin/bash 
+ 
+side="invalid" 
+mode="invalid" 
+addr="invalid" 
+ 
+while getopts "hdbtsa:" opt; do 
+ case "$opt" in 
+ h) side="-h" 
+ ;; 
+ d) side="-d" 
+ ;; 
+ b) side="-b" 
+ ;; 
+ t) mode="-t" 
+ ;; 
+ s) mode="-s" 
+ ;; 
+ a) addr=$OPTARG 
+ ;; 
+ esac 
+done 
+ 
+ 
+if [ "$side" == "invalid" ] 
+then 
+ echo $side 
+ echo "please choose host (-h) or device (-d)" 
+ exit 
+fi 
+ 
+if [ "$mode" == "invalid" ] 
+then 
+ echo $mode 
+ echo "please choose tcp (-t) or snap (-s)" 
+ exit 
+fi 
+ 
+if [ "$addr" == "invalid" ] 
+then 
+ echo $addr 
+ echo "please enter a valid address (-a 1.2.3.4, -a 01:23:45:67:89:0a)" 
+ exit 
+fi 
+ 
+ 
+cd ../ 
+# make clean && make 
+make -j8 
+cd drivers/ 
+ 
+wireshark -k -i eth0 & 
+ 
+sudo ../scripts/load_script.sh $side $mode 
+ 
+sudo cat /proc/modules | grep ma 
+ 
+if [ "$mode" == "-s" ] 
+then 
+ echo "connecting mausb" 
+ ../tools/mausb-util/mausb -c -m llc -a $addr 
+fi 
+ 
+if [ "$mode" == "-t" ] 
+then 
+ echo "connecting mausb" 
+ ../tools/mausb-util/mausb -c -m ip -p 9001 -a $addr 
+fi 
+ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/load_gzero.sh linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/load_gzero.sh
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/load_gzero.sh	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/load_gzero.sh	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,5 @@
+#!/bin/bash 
+ 
+modprobe g_zero 
+ 
+echo g_zero load process complete 
\ No newline at end of file
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/load_mausb_android-dev.sh linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/load_mausb_android-dev.sh
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/load_mausb_android-dev.sh	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/load_mausb_android-dev.sh	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,31 @@
+#!/system/xbin/ash 
+ 
+# For Android targets, insmod shall be used since 
+# the ueventd take care of the dependencies. 
+ 
+GREEN="\\033[.1;32m" 
+NORMAL="\\033[.0;39m" 
+RED="\\033[.1;31m" 
+ 
+load_module() 
+{ 
+ insmod $1 
+ if [ $? -ne 0 ]; then 
+ echo -e $RED 
+ echo "unable to insmod $1 (err : $?)" 
+ echo -e $NORMAL 
+ exit $? 
+ fi 
+} 
+ 
+ 
+load_module /lib/modules/matcp_core.ko 
+load_module /lib/modules/maudc.ko 
+#load_module /lib/modules/mamed.ko 
+load_module /lib/modules/matcp_dev.ko 
+ 
+mknod /dev/mausb c 100 0 
+ 
+echo -e $GREEN 
+echo "mausb load process complete" 
+echo -e $NORMAL 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/load_mausb_android-host.sh linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/load_mausb_android-host.sh
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/load_mausb_android-host.sh	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/load_mausb_android-host.sh	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,31 @@
+#!/system/xbin/ash 
+ 
+# For Android targets, insmod shall be used since 
+# the ueventd take care of the dependencies. 
+ 
+GREEN="\\033[.1;32m" 
+NORMAL="\\033[.0;39m" 
+RED="\\033[.1;31m" 
+ 
+load_module() 
+{ 
+ insmod $1 
+ if [ $? -ne 0 ]; then 
+ echo -e $RED 
+ echo "unable to insmod $1 (err : $?)" 
+ echo -e $NORMAL 
+ exit $? 
+ fi 
+} 
+ 
+ 
+load_module /lib/modules/matcp_core.ko 
+load_module /lib/modules/mausb.ko 
+#load_module /lib/modules/mamed.ko 
+load_module /lib/modules/matcp_host.ko 
+ 
+mknod /dev/mausb c 100 0 
+ 
+echo -e $GREEN 
+echo "mausb load process complete" 
+echo -e $NORMAL 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/load_mausb_android.sh linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/load_mausb_android.sh
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/load_mausb_android.sh	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/load_mausb_android.sh	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,33 @@
+#!/system/xbin/ash 
+ 
+# For Android targets, insmod shall be used since 
+# the ueventd take care of the dependencies. 
+ 
+GREEN="\\033[.1;32m" 
+NORMAL="\\033[.0;39m" 
+RED="\\033[.1;31m" 
+ 
+load_module() 
+{ 
+ insmod $1 
+ if [ $? -ne 0 ]; then 
+ echo -e $RED 
+ echo "unable to insmod $1 (err : $?)" 
+ echo -e $NORMAL 
+ exit $? 
+ fi 
+} 
+ 
+ 
+load_module /lib/modules/matcp_core.ko 
+load_module /lib/modules/mausb.ko 
+load_module /lib/modules/maudc.ko 
+#load_module /lib/modules/mamed.ko 
+load_module /lib/modules/matcp_host.ko 
+load_module /lib/modules/matcp_dev.ko 
+ 
+mknod /dev/mausb c 100 0 
+ 
+echo -e $GREEN 
+echo "mausb load process complete" 
+echo -e $NORMAL 
\ No newline at end of file
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/load_script.sh linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/load_script.sh
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/load_script.sh	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/load_script.sh	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,125 @@
+#!/bin/bash 
+# This script is used for loading & unloading the mausb_driver 
+ 
+# note: this script must be run with root priviledge (for the modprobes) 
+ 
+side="invalid" 
+mode="invalid" 
+load="load" 
+ 
+# Determine weather to load a host or device in TCP mode or snap mode 
+while getopts "hdbtslu" opt; do 
+ case "$opt" in 
+ h) side="host" 
+ ;; 
+ d) side="device" 
+ ;; 
+ b) side="both" 
+ ;; 
+ t) mode="tcp" 
+ ;; 
+ s) mode="snap" 
+ ;; 
+ l) load="load" 
+ ;; 
+ u) load="unload" 
+ ;; 
+ esac 
+done 
+ 
+if [ "$side" == "invalid" ] 
+then 
+ echo $side 
+ echo "please choose host (-h) or device (-d)" 
+ exit 
+fi 
+ 
+if [ "$mode" == "invalid" ] 
+then 
+ echo $mode 
+ echo "please choose a tcp (-t) or snap (-s)" 
+ exit 
+fi 
+ 
+ 
+ 
+if [ "$load" == "load" ] 
+then 
+ # copy the LKM into the module library 
+ pushd $(dirname $0) 
+ cp ../drivers/*.ko /lib/modules/$(uname -r)/kernel/drivers/usb/ 
+ popd 
+ 
+ # depmod so the kernel can figure out its dependacies 
+ depmod -A 
+ 
+ # open the file for ioctl calls 
+ mknod /dev/mausb c 100 0 
+ 
+ modprobe_flags="" 
+ 
+elif [ "$load" == "unload" ] 
+then 
+ # unload the drivers instead of loading them 
+ modprobe_flags="-r" 
+ 
+fi 
+ 
+ 
+ 
+# load the drivers 
+ 
+if [ "$mode" == "tcp" ] && [ "$load" == "load" ] 
+then 
+ modprobe $modprobe_flags matcp_core 
+ 
+elif [ "$mode" == "snap" ] 
+then 
+ modprobe $modprobe_flags masnap_core 
+fi 
+ 
+ 
+if [ "$side" == "device" ] || [ "$side" == "both" ] 
+then 
+ if [ "$load" == "load" ] 
+ then 
+ modprobe $modprobe_flags maudc 
+ fi 
+ 
+ modprobe $modprobe_flags g_zero 
+ 
+ if [ "$mode" == "tcp" ] 
+ then 
+ modprobe $modprobe_flags matcp_dev 
+ 
+ elif [ "$mode" == "snap" ] 
+ then 
+ modprobe $modprobe_flags masnap_dev 
+ fi 
+fi 
+ 
+if [ "$side" == "host" ] || [ "$side" == "both" ] 
+then 
+ if [ "$load" == "load" ] 
+ then 
+ modprobe $modprobe_flags mausb 
+ fi 
+ 
+ if [ "$mode" == "tcp" ] 
+ then 
+ modprobe $modprobe_flags matcp_host 
+ 
+ elif [ "$mode" == "snap" ] 
+ then 
+ modprobe $modprobe_flags masnap_host 
+ fi 
+ 
+fi 
+ 
+if [ "$load" == "unload" ] 
+then 
+ modprobe $modprobe_flags maudc 
+ modprobe $modprobe_flags mausb 
+fi 
+ 
+echo "$load mausb $side $mode driver complete" 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/modprobify.sh linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/modprobify.sh
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/modprobify.sh	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/modprobify.sh	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,10 @@
+#!/bin/bash 
+ 
+ 
+# note: this scripted needs to be run as a superuser to work 
+ 
+# copy the LKM into the module library 
+cp ./*.ko /lib/modules/$(uname -r)/kernel/drivers/usb/ 
+ 
+# depmod so the kernel can figure out its dependacies 
+depmod -A 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/unload_gzero.sh linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/unload_gzero.sh
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/unload_gzero.sh	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/unload_gzero.sh	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,5 @@
+#!/bin/bash 
+ 
+modprobe -r g_zero 
+ 
+echo g_zero unload process complete 
\ No newline at end of file
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/TODO linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/TODO
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/TODO	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/TODO	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,5 @@
+TODO: 
+ - checkpatch.pl cleanups 
+ - address miscellaneous "TODO" statements in code 
+ - add support for multiple media agnostic (MA) devices 
+ - add/improve support for unimplemented packet types 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/tty/serial/8250/8250.c linux-linaro-3.4-2012.05-1_cavium/drivers/tty/serial/8250/8250.c
--- linux-linaro-3.4-2012.05-1_original/drivers/tty/serial/8250/8250.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/tty/serial/8250/8250.c	2014-07-29 17:28:38.819972000 +0800
@@ -47,6 +47,15 @@
 
 #include "8250.h"
 
+
+
+/* Offset for the DesignWare's UART Status Register. */
+#define UART_USR	0x1f
+
+struct dw8250_data {
+	int	last_lcr;
+	int	line;
+};
 /*
  * Configuration:
  *   share_irqs - whether we pass IRQF_SHARED to request_irq().  This option
@@ -394,14 +403,20 @@
 
 static void mem32_serial_out(struct uart_port *p, int offset, int value)
 {
+	struct dw8250_data *d = p->private_data;
+
+	if (offset == UART_LCR)
+		d->last_lcr = value;
+
 	offset = map_8250_out_reg(p, offset) << p->regshift;
-	writel(value, p->membase + offset);
+	writew(value, p->membase + offset);
 }
 
 static unsigned int mem32_serial_in(struct uart_port *p, int offset)
 {
-	offset = map_8250_in_reg(p, offset) << p->regshift;
-	return readl(p->membase + offset);
+	int test = 0;
+	test = map_8250_in_reg(p, offset) << p->regshift;
+	return readw(p->membase + test);
 }
 
 static unsigned int au_serial_in(struct uart_port *p, int offset)
@@ -1517,6 +1532,7 @@
 	struct uart_8250_port *up =
 		container_of(port, struct uart_8250_port, port);
 
+	//printk("serial8250_handle_irq 111\n");
 	if (iir & UART_IIR_NO_INT)
 		return 0;
 
@@ -1534,14 +1550,31 @@
 
 	spin_unlock_irqrestore(&port->lock, flags);
 	return 1;
+	//printk("serial8250_handle_irq 222\n");
 }
 EXPORT_SYMBOL_GPL(serial8250_handle_irq);
 
 static int serial8250_default_handle_irq(struct uart_port *port)
 {
+	struct dw8250_data *d = port->private_data;
+
+//	printk("serial8250_default_handle_irq : port = 0x%x\n",port);
 	unsigned int iir = serial_port_in(port, UART_IIR);
+//	printk("iir = 0x%x, UART_IIR = 0x%x\n",iir, UART_IIR);
+#if 1
+	if (serial8250_handle_irq(port, iir)) {
+		return 1;
+	} else if ((iir & UART_IIR_BUSY) == UART_IIR_BUSY) {
+		/* Clear the USR and write the LCR again. */
+		port->serial_in(port, UART_USR);
+		port->serial_out(port, UART_LCR, d->last_lcr);
+		return 0;
+	}
 
+	return 0;
+#else
 	return serial8250_handle_irq(port, iir);
+#endif
 }
 
 /*
@@ -1565,7 +1598,7 @@
 	int pass_counter = 0, handled = 0;
 
 	DEBUG_INTR("serial8250_interrupt(%d)...", irq);
-
+//printk("serial8250_interrupt(%d)...", irq);
 	spin_lock(&i->lock);
 
 	l = i->head;
@@ -1576,26 +1609,28 @@
 		up = list_entry(l, struct uart_8250_port, list);
 		port = &up->port;
 
+		//printk("serial8250_interrupt: irq = %d, handle_irq = 0x%x\n",port->irq,port->handle_irq);
 		if (port->handle_irq(port)) {
+			//printk("aaa\n");
 			handled = 1;
 			end = NULL;
-		} else if (end == NULL)
+		} else if (end == NULL){
 			end = l;
-
+			//printk("bbb\n");
+		}
 		l = l->next;
-
+		//printk("pass_counter = %d\n",pass_counter);
 		if (l == i->head && pass_counter++ > PASS_LIMIT) {
 			/* If we hit this, we're dead. */
-			printk_ratelimited(KERN_ERR
-				"serial8250: too much work for irq%d\n", irq);
+			printk("serial8250: too much work for irq%d\n", irq);
 			break;
 		}
 	} while (l != end);
 
 	spin_unlock(&i->lock);
 
-	DEBUG_INTR("end.\n");
-
+//	DEBUG_INTR("end.\n");
+//printk("end.\n");
 	return IRQ_RETVAL(handled);
 }
 
@@ -1633,6 +1668,7 @@
 	struct irq_info *i;
 	int ret, irq_flags = up->port.flags & UPF_SHARE_IRQ ? IRQF_SHARED : 0;
 
+//printk("%s : %s in line %d\n",__FILE__,__FUNCTION__,__LINE__);
 	mutex_lock(&hash_mutex);
 
 	h = &irq_lists[up->port.irq % NR_IRQ_HASH];
@@ -1667,8 +1703,11 @@
 		i->head = &up->list;
 		spin_unlock_irq(&i->lock);
 		irq_flags |= up->port.irqflags;
+		//printk("%s : %s in line %d\n",__FILE__,__FUNCTION__,__LINE__);
+		//printk("up->port.irq = %d\n",up->port.irq);
 		ret = request_irq(up->port.irq, serial8250_interrupt,
 				  irq_flags, "serial", i);
+		//printk("ret = %d\n",ret);
 		if (ret < 0)
 			serial_do_unlink(i, up);
 	}
@@ -2941,7 +2980,7 @@
 
 	if (port->line >= ARRAY_SIZE(serial8250_ports))
 		return -ENODEV;
-
+//printk("%s : %s in line %d\n",__FILE__,__FUNCTION__,__LINE__);
 	serial8250_isa_init_ports();
 	p = &serial8250_ports[port->line].port;
 	p->iobase       = port->iobase;
@@ -3015,7 +3054,11 @@
 	struct plat_serial8250_port *p = dev->dev.platform_data;
 	struct uart_port port;
 	int ret, i, irqflag = 0;
+	struct dw8250_data *data = devm_kzalloc(&dev->dev, sizeof(*data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
 
+	port.private_data = data;
 	memset(&port, 0, sizeof(struct uart_port));
 
 	if (share_irqs)
@@ -3041,6 +3084,12 @@
 		port.pm			= p->pm;
 		port.dev		= &dev->dev;
 		port.irqflags		|= irqflag;
+{
+		struct dw8250_data *data = devm_kzalloc(&dev->dev, sizeof(*data), GFP_KERNEL);
+		if (!data)
+			return -ENOMEM;
+		port.private_data = data;
+}
 		ret = serial8250_register_port(&port);
 		if (ret < 0) {
 			dev_err(&dev->dev, "unable to register port at index %d "
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/core/generic.c linux-linaro-3.4-2012.05-1_cavium/drivers/usb/core/generic.c
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/core/generic.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/core/generic.c	2014-07-29 17:28:38.819972000 +0800
@@ -149,6 +149,7 @@
 		dev_warn(&udev->dev,
 			"no configuration chosen from %d choice%s\n",
 			num_configs, plural(num_configs));
+		dev_warn(&udev->dev, "Not support over %dmA\n", udev->bus_mA);
 	}
 	return i;
 }
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/core/hcd.c linux-linaro-3.4-2012.05-1_cavium/drivers/usb/core/hcd.c
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/core/hcd.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/core/hcd.c	2014-07-29 17:28:38.819972000 +0800
@@ -615,6 +615,9 @@
 		case DeviceRequest | USB_REQ_GET_DESCRIPTOR:
 			/* len is returned by hub_control */
 			break;
+		case SetandTestPortFeature:
+			len = 1;
+			break;
 		}
 		status = hcd->driver->hub_control (hcd,
 			typeReq, wValue, wIndex,
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/core/hub.c linux-linaro-3.4-2012.05-1_cavium/drivers/usb/core/hub.c
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/core/hub.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/core/hub.c	2014-07-29 17:28:38.819972000 +0800
@@ -1669,6 +1669,14 @@
 	struct usb_device	*udev = *pdev;
 	int			i;
 
+#ifdef	CONFIG_USB_SNPS_DWC_OTG2
+	if (work_pending(&udev->hnp_poll_work.work)) {
+		while (!cancel_delayed_work(&udev->hnp_poll_work)) {
+			msleep(10);
+		}
+	}
+#endif
+
 	/* mark the device as inactive, so any further urb submissions for
 	 * this device (and any of its children) will fail immediately.
 	 * this quiesces everything except pending urbs.
@@ -1744,7 +1752,65 @@
 #endif
 
 #ifdef	CONFIG_USB_OTG
+static int enable_whitelist = 0;
+module_param(enable_whitelist, bool, S_IRUGO | S_IWUSR);
+MODULE_PARM_DESC(enable_whitelist,
+                 "only recognize devices in OTG whitelist if true");
+
 #include "otg_whitelist.h"
+
+#ifdef CONFIG_USB_SNPS_DWC_OTG2
+int usb_port_suspend(struct usb_device *udev, pm_message_t msg);
+static void hnp_poll_timeout(struct work_struct* w)
+{
+	struct usb_device *udev = container_of(w, struct usb_device, hnp_poll_work.work);
+	uint8_t otgstatus;
+	int ret;
+	int err;
+	
+	ret = usb_control_msg(udev, 
+			usb_rcvctrlpipe(udev, 0),
+			USB_REQ_GET_STATUS,
+			USB_DIR_IN | USB_RECIP_DEVICE,
+			0,
+			0xF000,
+			&otgstatus,
+			sizeof(otgstatus),
+			USB_CTRL_GET_TIMEOUT);
+
+	printk("otgstatus - 0x%4X\n", otgstatus);
+	
+	if(ret == sizeof(otgstatus) && (otgstatus & 0x1)){
+	    /* enable HNP before suspend, it's simpler */
+	    if (udev->portnum == udev->bus->otg_port) 
+			udev->bus->b_hnp_enable = 1;
+			err = usb_control_msg(udev,
+				usb_sndctrlpipe(udev, 0),
+				USB_REQ_SET_FEATURE, 0,
+				udev->bus->b_hnp_enable
+				? USB_DEVICE_B_HNP_ENABLE
+				: USB_DEVICE_A_ALT_HNP_SUPPORT,
+				0, NULL, 0, USB_CTRL_SET_TIMEOUT);
+
+		printk("SET FEATURE B_HNP_ENABLE %d\n",err);
+		
+	    if (err < 0) {
+		/* OTG MESSAGE: report errors here,
+ * 		 * customize to match your product.
+ * 		 		 */
+			dev_info(&udev->dev, "can't set HNP mode; %d\n", err);
+			dev_printk(KERN_CRIT, &udev->dev, 
+						"Device Not Connected/Responding\n");
+			udev->bus->b_hnp_enable = 0;
+	    }
+	    if (usb_port_suspend(udev, PMSG_SUSPEND) < 0) {
+			dev_dbg(&udev->dev, "HNP fail, %d\n", err);
+	    }
+	} else {
+	    schedule_delayed_work(&udev->hnp_poll_work, 1*HZ);
+	}
+}
+#endif
 #endif
 
 /**
@@ -1773,14 +1839,29 @@
 		if (__usb_get_extra_descriptor (udev->rawdescriptors[0],
 					le16_to_cpu(udev->config[0].desc.wTotalLength),
 					USB_DT_OTG, (void **) &desc) == 0) {
+			/* Check if the device supports HNP and start HNP polling if needed */
 			if (desc->bmAttributes & USB_OTG_HNP) {
 				unsigned		port1 = udev->portnum;
+#ifdef CONFIG_USB_SNPS_DWC_OTG2			
+				/* Start HNP Polling for OTG 2.0. */
+				if ((desc->bcdOTG >= 0x0200) &&
+					(bus->otg_version >= 0x0200)) {
 
 				dev_info(&udev->dev,
-					"Dual-Role OTG device on %sHNP port\n",
+					"Dual-Role OTG 2.0 device on %sHNP port\n",
+					(port1 == bus->otg_port)
+						? "" : "non-");
+					if (port1 == bus->otg_port) {
+						INIT_DELAYED_WORK(&udev->hnp_poll_work, hnp_poll_timeout);
+						schedule_delayed_work(&udev->hnp_poll_work, HZ);
+					}
+					goto done_hnp;
+				}
+#endif
+				dev_info(&udev->dev,
+					"Dual-Role OTG 1.3 device on %sHNP port\n",
 					(port1 == bus->otg_port)
 						? "" : "non-");
-
 				/* enable HNP before suspend, it's simpler */
 				if (port1 == bus->otg_port)
 					bus->b_hnp_enable = 1;
@@ -1798,23 +1879,42 @@
 					dev_info(&udev->dev,
 						"can't set HNP mode: %d\n",
 						err);
+					dev_printk(KERN_CRIT, &udev->dev, 
+						"Device Not Connected/Responding\n");
 					bus->b_hnp_enable = 0;
-				}
+				} else 
+					dev_info(&udev->dev, "HNP Not Supported\n");
 			}
 		}
 	}
-
+#ifdef CONFIG_USB_SNPS_DWC_OTG2
+done_hnp:
+#endif
 	if (!is_targeted(udev)) {
 
 		/* Maybe it can talk to us, though we can't talk to it.
 		 * (Includes HNP test device.)
 		 */
-		if (udev->bus->b_hnp_enable || udev->bus->is_b_host) {
+		if (udev->bus->b_hnp_enable || udev->bus->is_b_host ||
+                    udev->descriptor.idVendor == 0x1a0a) {
 			err = usb_port_suspend(udev, PMSG_SUSPEND);
 			if (err < 0)
 				dev_dbg(&udev->dev, "HNP fail, %d\n", err);
+			else {
+				/* Return Connection Refused(ECONNREFUSED)
+				* instead of Not Supported(ENOTSUPP) so that the
+ 				* retry loop in hub_port_connect_change() is
+				* exited without disabling the port
+				*/
+			    err = -ECONNREFUSED;
+			    goto fail;
+			}
 		}
-		err = -ENOTSUPP;
+		/* Return Not Connected (ENOTCONN) instead of Not 
+		 * Supported(ENOTSUPP) so that the retry loop in 
+ 		 * hub_port_connect_change() is exited
+ 		 */
+		err = -ENOTCONN;
 		goto fail;
 	}
 fail:
@@ -3530,14 +3630,15 @@
 		return;
 
 loop_disable:
+		if(status != -ECONNREFUSED)
 		hub_port_disable(hub, port1, 1);
 loop:
 		usb_ep0_reinit(udev);
 		release_devnum(udev);
 		hub_free_dev(udev);
 		usb_put_dev(udev);
-		if ((status == -ENOTCONN) || (status == -ENOTSUPP))
-			break;
+		if (status == -ENOTCONN || status == -ECONNREFUSED)
+			return;
 	}
 	if (hub->hdev->parent ||
 			!hcd->driver->port_handed_over ||
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/core/message.c linux-linaro-3.4-2012.05-1_cavium/drivers/usb/core/message.c
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/core/message.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/core/message.c	2014-07-29 17:28:38.819972000 +0800
@@ -1838,6 +1838,86 @@
 			!(dev->quirks & USB_QUIRK_CONFIG_INTF_STRINGS))
 		cp->string = usb_cache_string(dev, cp->desc.iConfiguration);
 
+/* Uncomment this define to enable the HS Electrical Test support */
+#define DWC_HS_ELECT_TST 1
+#ifdef DWC_HS_ELECT_TST
+	/* Here we implement the HS Electrical Test support. The
+	 * tester uses a vendor ID of 0x1A0A to indicate we should
+	 * run a special test sequence. The product ID tells us
+	 * which sequence to run. We invoke the test sequence by
+	 * sending a non-standard SetFeature command to our root
+	 * hub port. Our dwc_otg_hcd_hub_control() routine will
+	 * recognize the command and perform the desired test
+	 * sequence.
+	 */
+	if (dev->descriptor.idVendor == 0x1A0A) {
+		/* HSOTG Electrical Test */
+		dev_warn(&dev->dev, "VID from HSOTG Electrical Test Fixture\n");
+
+		if (dev->bus && dev->bus->root_hub) {
+			struct usb_device *hdev = dev->bus->root_hub;
+			dev_warn(&dev->dev, "Got PID 0x%x\n", dev->descriptor.idProduct);
+
+			switch (dev->descriptor.idProduct) {
+			case 0x0101:	/* TEST_SE0_NAK */
+				dev_warn(&dev->dev, "TEST_SE0_NAK\n");
+				usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+					USB_REQ_SET_FEATURE, USB_RT_PORT,
+					USB_PORT_FEAT_TEST, 0x300, NULL, 0, HZ);
+				break;
+
+			case 0x0102:	/* TEST_J */
+				dev_warn(&dev->dev, "TEST_J\n");
+				usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+					USB_REQ_SET_FEATURE, USB_RT_PORT,
+					USB_PORT_FEAT_TEST, 0x100, NULL, 0, HZ);
+				break;
+
+			case 0x0103:	/* TEST_K */
+				dev_warn(&dev->dev, "TEST_K\n");
+				usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+					USB_REQ_SET_FEATURE, USB_RT_PORT,
+					USB_PORT_FEAT_TEST, 0x200, NULL, 0, HZ);
+				break;
+
+			case 0x0104:	/* TEST_PACKET */
+				dev_warn(&dev->dev, "TEST_PACKET\n");
+				usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+					USB_REQ_SET_FEATURE, USB_RT_PORT,
+					USB_PORT_FEAT_TEST, 0x400, NULL, 0, HZ);
+				break;
+
+			case 0x0105:	/* TEST_FORCE_ENABLE */
+				dev_warn(&dev->dev, "TEST_FORCE_ENABLE\n");
+				usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+					USB_REQ_SET_FEATURE, USB_RT_PORT,
+					USB_PORT_FEAT_TEST, 0x500, NULL, 0, HZ);
+				break;
+
+			case 0x0106:	/* HS_HOST_PORT_SUSPEND_RESUME */
+				dev_warn(&dev->dev, "HS_HOST_PORT_SUSPEND_RESUME\n");
+				usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+					USB_REQ_SET_FEATURE, USB_RT_PORT,
+					USB_PORT_FEAT_TEST, 0x600, NULL, 0, 40 * HZ);
+				break;
+
+			case 0x0107:	/* SINGLE_STEP_GET_DEVICE_DESCRIPTOR setup */
+				dev_warn(&dev->dev, "SINGLE_STEP_GET_DEVICE_DESCRIPTOR setup\n");
+				usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+					USB_REQ_SET_FEATURE, USB_RT_PORT,
+					USB_PORT_FEAT_TEST, 0x700, NULL, 0, 40 * HZ);
+				break;
+
+			case 0x0108:	/* SINGLE_STEP_GET_DEVICE_DESCRIPTOR execute */
+				dev_warn(&dev->dev, "SINGLE_STEP_GET_DEVICE_DESCRIPTOR execute\n");
+				usb_control_msg(hdev, usb_sndctrlpipe(hdev, 0),
+					USB_REQ_SET_FEATURE, USB_RT_PORT,
+					USB_PORT_FEAT_TEST, 0x800, NULL, 0, 40 * HZ);
+				}
+			}
+		}
+#endif /* DWC_HS_ELECT_TST */
+
 	/* Now that all the interfaces are set up, register them
 	 * to trigger binding of drivers to interfaces.  probe()
 	 * routines may install different altsettings and may
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/core/otg_whitelist.h linux-linaro-3.4-2012.05-1_cavium/drivers/usb/core/otg_whitelist.h
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/core/otg_whitelist.h	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/core/otg_whitelist.h	2014-07-29 17:28:38.819972000 +0800
@@ -19,33 +19,67 @@
 static struct usb_device_id whitelist_table [] = {
 
 /* hubs are optional in OTG, but very handy ... */
+#define CERT_WITHOUT_HUBS
+#if defined(CERT_WITHOUT_HUBS)
+{ USB_DEVICE( 0x0000, 0x0000 ), }, /* Root HUB Only*/
+/* 
+ * These are for root hub and should be recognised always, 
+ * so correct it according to your system...
+ */
+{ USB_DEVICE( 0x1d6b, 0x0001 ), }, /* Root HUB Only*/
+{ USB_DEVICE( 0x1d6b, 0x0002 ), }, /* Root HUB Only*/
+#else
 { USB_DEVICE_INFO(USB_CLASS_HUB, 0, 0), },
 { USB_DEVICE_INFO(USB_CLASS_HUB, 0, 1), },
+{ USB_DEVICE_INFO(USB_CLASS_HUB, 0, 2), },
+#endif
 
 #ifdef	CONFIG_USB_PRINTER		/* ignoring nonstatic linkage! */
 /* FIXME actually, printers are NOT supposed to use device classes;
  * they're supposed to use interface classes...
  */
-{ USB_DEVICE_INFO(7, 1, 1) },
-{ USB_DEVICE_INFO(7, 1, 2) },
-{ USB_DEVICE_INFO(7, 1, 3) },
+//{ USB_DEVICE_INFO(7, 1, 1) },
+//{ USB_DEVICE_INFO(7, 1, 2) },
+//{ USB_DEVICE_INFO(7, 1, 3) },
 #endif
 
 #ifdef	CONFIG_USB_NET_CDCETHER
 /* Linux-USB CDC Ethernet gadget */
-{ USB_DEVICE(0x0525, 0xa4a1), },
+//{ USB_DEVICE(0x0525, 0xa4a1), },
 /* Linux-USB CDC Ethernet + RNDIS gadget */
-{ USB_DEVICE(0x0525, 0xa4a2), },
+//{ USB_DEVICE(0x0525, 0xa4a2), },
 #endif
 
 #if	defined(CONFIG_USB_TEST) || defined(CONFIG_USB_TEST_MODULE)
 /* gadget zero, for testing */
-{ USB_DEVICE(0x0525, 0xa4a0), },
+//{ USB_DEVICE(0x0525, 0xa4a0), },
 #endif
 
+{ USB_DEVICE( 0x1a0a, 0x0101 ), }, /* TEST_SE0_NAK */
+{ USB_DEVICE( 0x1a0a, 0x0102 ), }, /* Test_J */
+{ USB_DEVICE( 0x1a0a, 0x0103 ), }, /* Test_K */
+{ USB_DEVICE( 0x1a0a, 0x0104 ), }, /* Test_PACKET */
+{ USB_DEVICE( 0x1a0a, 0x0105 ), }, /* Test_FORCE_ENABLE */
+{ USB_DEVICE( 0x1a0a, 0x0106 ), }, /* HS_PORT_SUSPEND_RESUME  */
+{ USB_DEVICE( 0x1a0a, 0x0107 ), }, /* SINGLE_STEP_GET_DESCRIPTOR setup */
+{ USB_DEVICE( 0x1a0a, 0x0108 ), }, /* SINGLE_STEP_GET_DESCRIPTOR execute */
+{ USB_DEVICE_VER(0x054c,0x0010,0x0410, 0x0500), },
+{ USB_DEVICE( 0x0EA0, 0x2168 ), }, /* Ours Technology Inc. (BUFFALO ClipDrive)*/
 { }	/* Terminating entry */
 };
 
+static inline void report_errors(struct usb_device *dev)
+{
+	dev_info(&dev->dev, "device Vendor:%04x Product:%04x is not supported\n",
+		 le16_to_cpu(dev->descriptor.idVendor),
+		 le16_to_cpu(dev->descriptor.idProduct));
+        if (USB_CLASS_HUB == dev->descriptor.bDeviceClass){
+                dev_printk(KERN_CRIT, &dev->dev, "Unsupported Hub Topology\n");
+        } else {        
+                dev_printk(KERN_CRIT, &dev->dev, "Attached Device is not Supported\n");
+        }
+}
+
 static int is_targeted(struct usb_device *dev)
 {
 	struct usb_device_id	*id = whitelist_table;
@@ -56,13 +90,33 @@
 
 	/* HNP test device is _never_ targeted (see OTG spec 6.6.6) */
 	if ((le16_to_cpu(dev->descriptor.idVendor) == 0x1a0a &&
-	     le16_to_cpu(dev->descriptor.idProduct) == 0xbadd))
+	     le16_to_cpu(dev->descriptor.idProduct) == 0xbadd)) {
 		return 0;
+	} else if (!enable_whitelist) {
+		return 1;
+        } else {
+#ifdef DEBUG
+                dev_dbg(&dev->dev, "device V:%04x P:%04x DC:%04x SC:%04x PR:%04x \n",
+                        dev->descriptor.idVendor,
+                        dev->descriptor.idProduct,
+                        dev->descriptor.bDeviceClass,
+                        dev->descriptor.bDeviceSubClass,
+                        dev->descriptor.bDeviceProtocol);
+#endif
 
 	/* NOTE: can't use usb_match_id() since interface caches
 	 * aren't set up yet. this is cut/paste from that code.
 	 */
 	for (id = whitelist_table; id->match_flags; id++) {
+#ifdef DEBUG
+		dev_dbg(&dev->dev, 
+			"ID: V:%04x P:%04x DC:%04x SC:%04x PR:%04x \n",
+			id->idVendor,
+			id->idProduct,
+			id->bDeviceClass,
+			id->bDeviceSubClass,
+			id->bDeviceProtocol);
+#endif
 		if ((id->match_flags & USB_DEVICE_ID_MATCH_VENDOR) &&
 		    id->idVendor != le16_to_cpu(dev->descriptor.idVendor))
 			continue;
@@ -95,6 +149,7 @@
 
 		return 1;
 	}
+	}
 
 	/* add other match criteria here ... */
 
@@ -104,9 +159,15 @@
 		le16_to_cpu(dev->descriptor.idVendor),
 		le16_to_cpu(dev->descriptor.idProduct));
 #ifdef	CONFIG_USB_OTG_WHITELIST
+	report_errors(dev);
 	return 0;
 #else
-	return 1;
+	if (enable_whitelist) {
+		report_errors(dev);
+		return 0;
+	} else {
+		return 1;
+	}
 #endif
 }
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/f_hid.c linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/f_hid.c
